//   Steel Shapes Dialog Box  Version 4.3
//
//   (C) Copyright 1999 by Design Point
//   All rights reserved
//
//   This program is copyrighted by Design Point and is licensed
//   to you under the following conditions.  You may not distribute
//   or publish the source code of this program in any form.
//
//   DESIGN POINT PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//   DESIGN POINT SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MER-
//   CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  DESIGN POINT
//   DOES NOT WARRANT THAT THE OPERATION OF THIS OR PARTS OF THIS
//   PROGRAM WILL BE UNINTERRUPTED OR ERROR FREE.
//

// This file to be used in conjuction with STEEL.LSP

steel_shapes : dialog {
   label = "Select Steel Shape";
   : text {
      key = "stl_current_shape";
      label = "";
   }
   : row {
      : column {
         : text {
            label = "Shape";
            alignment = centered;
         }
         : list_box {
            key = stl_shapes;
            width = 20;
            height = 13;
            fixed_width = true;
         }
      }
      : column {
         : text {
            label = "";
            key   = size_a_label;
            alignment = centered;
         }
         : list_box {
            key = stl_size_a;
            width = 20;
            height = 13;
            fixed_width = true;
         }
      }
      : column {
         : text {
            label = "";
            key   = size_b_label;
            alignment = centered;
         }
         : list_box {
            key = stl_size_b;
            allow_accept = true;
            width = 20;
            height = 13;
            fixed_width = true;
         }
      }
      : boxed_column {
         label = "Shape Data";
         width = 40;
         fixed_width = true;
         : text {
            label = "";
            key = shp_size;
            height = 1.3;
         }
         : text {
            label = "";
            key = shp_flange;
            height = 1.3;
         }
         : text {
            label = "";
            key = shp_web;
            height = 1.3;
         }
         : text {
            label = "";
            key = shp_halfweb;
            height = 1.3;
         }
         : text {
            label = "";
            key = shp_stiff;
            height = 1.3;
         }
         : text {
            label = "";
            key = shp_gage;
            height = 1.3;
         }
         : text {
            label = "";
            key = shp_cope;
            height = 1.3;
         }
      }
   }
   : boxed_radio_row {
      label = "Visualization Mode";
      key   = "stl_vis_mode";
      fixed_height = true;
      fixed_width = true;
      : radio_button {
         label = "2d";
         key   = "stl_vma";
         action = "(stl_vis \"stl_vma\")";
      }
      : radio_button {
         label = "3d";
         key   = "stl_vmb";
         action = "(stl_vis \"stl_vmb\")";
      }
      : text {
         label = "                            ";
      }
   }
   : row {
      : boxed_radio_column {
         label = "View Mode";
         key   = "stl_view_mode";
         alignment = centered;
         : radio_button {
            label = "Front Elevation";
            key   = "stl_va";
         }
         : radio_button {
            label = "Rear Elevation";
            key   = "stl_vb";
         }
         : radio_button {
            label = "Top View";
            key   = "stl_vc";
         }
         : radio_button {
            label = "Bottom Section";
            key   = "stl_vd";
         }
         : radio_button {
            label = "Cross Section";
            key   = "stl_ve";
         }
      }
      : boxed_radio_column {
         label = "Input Mode";
         key   = "stl_input_mode";
         : radio_button {
            label = "Top Of Steel";
            key   = "stl_ia";
         }
         : radio_button {
            label = "Bottom of Steel";
            key   = "stl_ib";
         }
         : radio_button {
            label = "X Axis";
            key   = "stl_ic";
         }
         : radio_button {
            label = "Y Axis";
            key   = "stl_id";
            is_enabled = false;
         }
      }
      : column {
         : boxed_radio_column {
            label = "Draw Mode";
            key   = "stl_draw_mode";
            : radio_button {
               label = "Real";
               key   = "stl_da";
            }
            : radio_button {
               label = "Exaggerated";
               key   = "stl_db";
            }
         }
         : boxed_radio_column {
            label = "Auto-Hatching";
            key   = "stl_hatch_mode";
            : radio_button {
               label = "On";
               key   = "stl_ha";
            }
            : radio_button {
               label = "Off";
               key   = "stl_hb";
            }
         }
      }
   }
   : text {
      key = "stl_err_msg";
      label = "";
   }
   : row {
      alignment   = centered;
      fixed_width = true;
      : button {
         label      = "OK";
         key        = "stl_accept";
         width      = 10;
         is_default = true;
      }
      : button {
         label     = "Cancel";
         key       = "stl_cancel";
         width     = 10;
         is_cancel = true;
      }
      : button {
         label = "About";
         key   = "about_button";
         width = 10;
      }
   }
}
stl_about : dialog {
   label = "About Steel Shapes";
   : boxed_row {
      : paragraph {
         : text_part {
            alignment   = centered;
            label       = "Steel Shapes (tm)";
         }
         : text_part {
            alignment   = centered;
            label       = "Version 4.3";
         }
         : text_part {
            alignment   = centered;
            label       = "(c) Copyright Design Point 1999";
         }
         : text_part {
            alignment   = centered;
            label       = "All Rights Reserved";
            is_cancel = true;
         }
         spacer_1;
         : text_part {
            alignment   = centered;
            label       = "Visit our web site at";
            is_cancel = true;
         }
         : text_part {
            alignment   = centered;
            label       = "http://www.designpt.com";
            is_cancel = true;
         }
         spacer_1;
         : text_part {
            alignment   = centered;
            label       = "Address comments to luke@designpt.com";
            is_cancel = true;
         }
         spacer_1;
      }
   }
   ok_only;
}





