;Draw 3d Tube Shape
(apply '(lambda ( / a b c wallthk inside halflong halfshrt a90 a270 ip1 ip2
                    cp1 cp2 p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16)
   (setvar "cmdecho" 0)
   (princ (strcat "\nDrawing 3d View of [" (nth 0 SHP_DATA) "]"))
   (setq ip1
      (cond
         ((= STL_INPUT_MODE "stl_ia") (setq b 1) (getpoint "\n[PICK] Center point at Top Face of Tube point: "))
         ((= STL_INPUT_MODE "stl_ib") (setq b 2) (getpoint "\n[PICK] Center point at Bottom Face of Tube point: "))
         ((= STL_INPUT_MODE "stl_ic") (setq b 3) (getpoint "\n[PICK] Center point: "))
      )
   )
   (setq wallthk (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 3 SHP_DATA)))   ;Draw Mode
   (while (setq ip2 (getpoint ip1 "\n[PICK] End point: "))
      (setq inside (- (nth 1 shp_data) (* wallthk 2.0))
            halflong (/ (nth 1 shp_data) 2.0)
            halfshrt (/ (nth 2 shp_data) 2.0)
      )
      (setq a90  (+ (angle ip1 ip2) (* pi 0.5))
            a270 (+ (angle ip1 ip2) (* pi 1.5))
      )
      (cond
         ((= b 1) (setq cp1 ip1 cp2 ip2))
         ((= b 2)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) (nth 1 SHP_DATA)))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) (nth 1 SHP_DATA)))
            )
         )
         ((= b 3)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) halflong))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) halflong))
            )
         )
      )
      (setq p1 (polar cp1 a90 halfshrt)
            p4 (polar cp2 a90 halfshrt)
            p2 (polar cp1 a270 halfshrt)
            p3 (polar cp2 a270 halfshrt)
            p5 (polar p1 a270 wallthk)
            p8 (polar p4 a270 wallthk)
            p6 (polar p2 a90  wallthk)
            p7 (polar p3 a90  wallthk)
            p13 (list (car p1) (cadr p1) (- (caddr p1) (nth 1 shp_data)))
            p14 (list (car p2) (cadr p2) (- (caddr p2) (nth 1 shp_data)))
            p16 (list (car p4) (cadr p4) (- (caddr p4) (nth 1 shp_data)))
            p15 (list (car p3) (cadr p3) (- (caddr p3) (nth 1 shp_data)))
            p5 (list (car p5) (cadr p5) (- (caddr p5) wallthk))
            p6 (list (car p6) (cadr p6) (- (caddr p6) wallthk))
            p7 (list (car p7) (cadr p7) (- (caddr p7) wallthk))
            p8 (list (car p8) (cadr p8) (- (caddr p8) wallthk))
            p9  (list (car p5) (cadr p5) (- (caddr p5) inside))
            p10 (list (car p6) (cadr p6) (- (caddr p6) inside))
            p11 (list (car p7) (cadr p7) (- (caddr p7) inside))
            p12 (list (car p8) (cadr p8) (- (caddr p8) inside))
      )
      (setq shp_list
         (list p1  p2  p3  p4  p5  p6  p7  p8
               p9  p10 p11 p12 p13 p14 p15 p16 ""
                1   2   3  4 ""
                2  14  15  3 ""
               13  16  15 14 ""
               13   1   4 16 ""
                5   8   7  6 ""
                6   7  11 10 ""
                9  10  11 12 ""
                5   9  12  8 ""

                2  -1  5  -6 ""
                1 -13  9  -5 ""
               10  -9 13 -14 ""
                6 -10 14  -2 ""

                4  -3  7  -8 ""
                3 -15 11  -7 ""
               15 -16 12 -11 ""
                8 -12 16  -4 "" ""
         )
      )
      (stl_set_lyr "stl-objt")
      (setq a (list "blipmode" "osmode"))
      (setq c (mapcar 'getvar a))
      (command ".pface")
      (mapcar 'command shp_list)
      (mapcar 'setvar a c)
      (setq ip1 ip2)
      (setvar "lastpoint" ip2)
   )
   (princ)
)
'()
)

