;Draw WT Cross Section
(apply '(lambda ( / a b c d e f ang1 ang2 p1 p2 p3 p4 p5 p6 p7 p8 p9
                    p10 d1 d2 t1 p0 ad cp l m n r lp)
   (setq a (getvar "blipmode"))
   (princ (strcat "\nDrawing Section of [" (nth 0 SHP_DATA) "]"))
   (while
      (setq p1
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getpoint "\n[PICK] Center Top of Steel point: "))
            ((= STL_INPUT_MODE "stl_ib") (getpoint "\n[PICK] Center Bottom of Steel point: "))
            ((= STL_INPUT_MODE "stl_ic") (getpoint "\n[PICK] X Axis at Center of Stem: "))
            ((= STL_INPUT_MODE "stl_id") (getpoint "\n[PICK] Y Axis at Top of Flange: "))
         )
      )
      (setq lp p1)
      (setq b (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))  ;Web thickness
      (setq c (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 4 SHP_DATA)))  ;Flange thickness
      (setq ad nil cp nil)
      (command ".undo" "g")
      (setvar "blipmode" 0)
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (initget 1)
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (setq ang1 (getangle p1 "\nIndicate angle of Stem: "))
            (if (and (> ang1 0) (<= ang1 pi)) (setq ang1 (+ ang1 pi)))
            (setq wp (polar p1 ang1 (/ (nth 1 SHP_DATA) 2.0)))
            (foreach f (list ang1 (+ ang1 pi))
               (setq ang2 (+ f (* pi 0.5))
                     p0  (polar wp (+ f pi) (/ (nth 1 SHP_DATA) 2.0))
                     p1  (polar p0 ang2 (/ (nth 3 SHP_DATA) 2.0))
                     p10 (polar p1 (+ ang2 pi) (nth 3 SHP_DATA))
                     p4  (polar p0 f (nth 5 SHP_DATA))
                     p4  (polar p4 ang2 (/ b 2.0))
                     p3  (polar p4 ang2 (- (nth 5 SHP_DATA) c))
                     p3  (polar p3 (+ f pi) (distance p4 p3))
                     p7  (polar p4 (+ ang2 pi) b)
                     p8  (polar p7 (+ ang2 pi) (- (nth 5 SHP_DATA) c))
                     p8  (polar p8 (+ f pi) (distance p7 p8))
                     p2  (polar p1 f c)
                     p9  (polar p10 f c)
                     p5  (polar p0 f (nth 1 SHP_DATA))
                     p5  (polar p5 ang2 (/ b 2.0))
                     p6  (polar p5 (+ ang2 pi) b)
               )
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p10 p10 p1))
                  )
               )
               (setq cp (append cp (list p1 p10)))
            )
         )
         ((= STL_INPUT_MODE "stl_ib")
            (setq ang1 (getangle p1 "\nIndicate angle of Stem: "))
            (if (or (<= ang1 0) (> ang1 pi))  (setq ang1 (+ ang1 pi)))
            (setq wp (polar p1 ang1 (/ (nth 1 SHP_DATA) 2.0)))
            (foreach f (list ang1 (+ ang1 pi))
               (setq ang2 (+ f (* pi 0.5))
                     p0  (polar wp (+ f pi) (/ (nth 1 SHP_DATA) 2.0))
                     p1  (polar p0 ang2 (/ (nth 3 SHP_DATA) 2.0))
                     p10 (polar p1 (+ ang2 pi) (nth 3 SHP_DATA))
                     p4  (polar p0 f (nth 5 SHP_DATA))
                     p4  (polar p4 ang2 (/ b 2.0))
                     p3  (polar p4 ang2 (- (nth 5 SHP_DATA) c))
                     p3  (polar p3 (+ f pi) (distance p4 p3))
                     p7  (polar p4 (+ ang2 pi) b)
                     p8  (polar p7 (+ ang2 pi) (- (nth 5 SHP_DATA) c))
                     p8  (polar p8 (+ f pi) (distance p7 p8))
                     p2  (polar p1 f c)
                     p9  (polar p10 f c)
                     p5  (polar p0 f (nth 1 SHP_DATA))
                     p5  (polar p5 ang2 (/ b 2.0))
                     p6  (polar p5 (+ ang2 pi) b)
               )
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p10 p10 p1))
                  )
               )
               (setq cp (append cp (list p1 p10)))
            )
         )
         ((= STL_INPUT_MODE "stl_ic")
            (setq ang1 (getangle p1 "\nIndicate direction X Axis: "))
            (stl_set_lyr "stl-cntr")
            (command ".line"
               (polar p1 (+ ang1 pi) 6.0)
               (polar p1 ang1 6.0) "")
            (setq wp p1 ang1 (+ ang1 (* pi 0.5)))
            (foreach f (list ang1 (+ ang1 pi))
               (setq ang2 (+ f (* pi 0.5))
                     p0  (polar wp (+ f pi) (nth 6 SHP_DATA))
                     p1  (polar p0 ang2 (/ (nth 3 SHP_DATA) 2.0))
                     p10 (polar p1 (+ ang2 pi) (nth 3 SHP_DATA))
                     p4  (polar p0 f (nth 5 SHP_DATA))
                     p4  (polar p4 ang2 (/ b 2.0))
                     p3  (polar p4 ang2 (- (nth 5 SHP_DATA) c))
                     p3  (polar p3 (+ f pi) (distance p4 p3))
                     p7  (polar p4 (+ ang2 pi) b)
                     p8  (polar p7 (+ ang2 pi) (- (nth 5 SHP_DATA) c))
                     p8  (polar p8 (+ f pi) (distance p7 p8))
                     p2  (polar p1 f c)
                     p9  (polar p10 f c)
                     p5  (polar p0 f (nth 1 SHP_DATA))
                     p5  (polar p5 ang2 (/ b 2.0))
                     p6  (polar p5 (+ ang2 pi) b)
               )
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p10 p10 p1))
                  )
               )
               (setq cp (append cp (list p1 p10)))
            )
         )
         ((= STL_INPUT_MODE "stl_id")
            (setq ang1 (getangle p1 "\nIndicate direction Y Axis: "))
            (setq wp p1)
            (foreach f (list ang1 (+ ang1 pi))
               (setq ang2 (+ f (* pi 0.5))
                     p0  wp
                     p1  (polar p0 ang2 (/ (nth 3 SHP_DATA) 2.0))
                     p10 (polar p1 (+ ang2 pi) (nth 3 SHP_DATA))
                     p4  (polar p0 f (nth 5 SHP_DATA))
                     p4  (polar p4 ang2 (/ b 2.0))
                     p3  (polar p4 ang2 (- (nth 5 SHP_DATA) c))
                     p3  (polar p3 (+ f pi) (distance p4 p3))
                     p7  (polar p4 (+ ang2 pi) b)
                     p8  (polar p7 (+ ang2 pi) (- (nth 5 SHP_DATA) c))
                     p8  (polar p8 (+ f pi) (distance p7 p8))
                     p2  (polar p1 f c)
                     p9  (polar p10 f c)
                     p5  (polar p0 f (nth 1 SHP_DATA))
                     p5  (polar p5 ang2 (/ b 2.0))
                     p6  (polar p5 (+ ang2 pi) b)
               )
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p9 p9 p10 p10 p1))
                  )
               )
               (setq cp (append cp (list p5 p6)))
            )
         )
      )
      (setq lp (polar lp ang1 (nth 1 SHP_DATA)))
      (command ".undo" "g")
      (setvar "blipmode" 0)
      (stl_set_lyr "stl-cntr")
      (command ".line"
         (polar wp (+ ang1 pi) (+ (/ (nth 1 SHP_DATA) 2.0) 6.0))
         (polar wp ang1 (+ (/ (nth 1 SHP_DATA) 2.0) 6.0)) "")
      (setq d1 (car ad) d2 (cadr ad) t1 d1)
      (setq p1 (car cp) p2 (cadr cp) p3 (caddr cp) p4 (cadddr cp))
      (grvecs d1)
      (princ "\n[DRAG] Stem direction and [PICK]: ")
      (grread 5)
      (while (/= 3 (car (setq l (grread 5))))
         (if (= 5 (car l))
            (progn
               (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) ang1 12.0) p1 p2 nil)))
               (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) ang1 12.0) p3 p4 nil)))
               (if (< n m)
                  (if (not (equal t1 d1))
                     (progn
                        (grvecs t1)
                        (grvecs d1)
                        (setq t1 d1)
                     )
                  )
                  (if (not (equal t1 d2))
                     (progn
                        (grvecs t1)
                        (grvecs d2)
                        (setq t1 d2)
                     )
                  )
               )
            )
         )
      )
      (grvecs t1)
      (setq d1 (cdr t1))
      (stl_set_lyr "stl-objt")
      (command ".pline" (car d1) "w" 0.0 ""
         (nth 1 d1) (nth 3 d1) "a"
         (nth 5 d1) "l"
         (nth 7 d1) (nth 9 d1) (nth 11 d1) "a"
         (nth 13 d1) "l"
         (nth 15 d1) (nth 17 d1) "c")
      (if (= STL_HATCH_MODE "stl_ha")
         (progn
            (stl_set_lyr "stl-htch")
            (command ".hatch" "steel" 4.0 (angtos (+ ang1 (* 0.5 pi))) "l" "")
         )
      )
      (setvar "osmode" r)
      (setvar "blipmode" a)
      (command ".undo" "e")
      (princ (strcat "\nDraw Section of [" (nth 0 SHP_DATA) "] again"))
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" a)
)
'()
)
