;TS Shape Cross Section

(apply '(lambda ( / a b c d e f m n r ad cp cl c0 c2 c3 c4 c5 p1 p2 p3 p4 p5 d1 d2
                    p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 tgl ang1 ang2 t1 t2 lp)
   (setq a (getvar "blipmode"))
   (princ (strcat "\nDrawing Section of [" (nth 0 SHP_DATA) "]"))
   (while
      (setq c1
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getpoint "\n[PICK] Top of Tube point: "))
            ((= STL_INPUT_MODE "stl_ib") (getpoint "\n[PICK] Bottom of Tube point: "))
            ((= STL_INPUT_MODE "stl_ic") (getpoint "\n[PICK] Center point: "))
            ((= STL_INPUT_MODE "stl_id") (getpoint "\n[PICK] Center point: "))
         )
      )
      (initget 1)
      (setq b (nth 1 SHP_DATA) c (nth 2 SHP_DATA))
      (setq ang1
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getangle c1 (strcat "\nIndicate rotation direction: ")))
            ((= STL_INPUT_MODE "stl_ib") (getangle c1 (strcat "\nIndicate rotation direction: ")))
            ((= STL_INPUT_MODE "stl_ic") (getangle c1 "\nIndicate X Axis direction: "))
            ((= STL_INPUT_MODE "stl_id") (getangle c1 "\nIndicate Y Axis direction: "))
         )
      )
      (setq d (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 3 SHP_DATA)))   ;Draw Mode
      (setq e (* d 0.33) ad nil cp nil cl nil)
      (command ".undo" "g")
      (setvar "blipmode" 0)
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (if (and (> ang1 0.0) (<= ang1 pi))
               (setq ang1 (+ ang1 pi))
            )
            (setq ang2 (+ ang1 (* pi 0.5)) tgl t)
            (foreach f (list (list b c) (list c b))
               (setq p1 (polar c1 ang2 (- (/ (cadr f) 2) (* d 2)))
                     p2 (polar c1 (angle p1 c1) (distance p1 c1))
                     c0 (polar c1 ang1 (/ (car f) 2.0))
                     c2 (polar c1 (+ ang1 pi) 6.0)
                     c3 (polar c0 ang1 (distance c2 c0))
                     c4 (polar c0 ang2 (+ (/ (cadr f) 2.0) 6.0))
                     c5 (polar c0 (+ ang2 pi) (distance c4 c0))
                     p3 (polar p2 (- ang1 (* pi 0.25)) (* (sqrt 2.0) (* d 2)))
                     p4 (polar p3 ang1 (- (car f) (* d 4)))
                     p5 (polar p2 ang1 (car f))
                     p6 (polar p1 ang1 (car f))
                     p7 (polar p4 ang2 (cadr f))
                     p8 (polar p3 ang2 (cadr f))
                     p9  (polar p1 ang1 d)
                     p10 (polar p2 ang1 d)
                     p11 (polar p3 ang2 d)
                     p12 (polar p4 ang2 d)
                     p13 (polar p5 (+ ang1 pi) d)
                     p14 (polar p6 (+ ang1 pi) d)
                     p15 (polar p7 (+ ang2 pi) d)
                     p16 (polar p8 (+ ang2 pi) d)
               )
               (setq ad
                  (append ad
                     (list
                        (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p1
                                  p9 p10 p10 p11 p11 p12 p12 p13 p13 p14 p14 p15 p15 p16 p16 p9
                        )
                     )
                  )
               )
               (setq cp (append cp (list p5 p6)))
               (setq cl (append cl (list (list c2 c3 c4 c5))))
            )
            (if (/= b c)
               (princ (strcat "\n[DRAG] direction of " (rtos c 4) " Leg and [PICK]:"))
            )
         )
         ((= STL_INPUT_MODE "stl_ib")
            (if (or (= ang1 0.0) (> ang1 pi))
               (setq ang1 (+ ang1 pi))
            )
            (setq ang2 (+ ang1 (* pi 0.5)) tgl t)
            (foreach f (list (list b c) (list c b))
               (setq p1 (polar c1 ang2 (- (/ (cadr f) 2) (* d 2)))
                     p2 (polar c1 (angle p1 c1) (distance p1 c1))
                     c0 (polar c1 ang1 (/ (car f) 2.0))
                     c2 (polar c1 (+ ang1 pi) 6.0)
                     c3 (polar c0 ang1 (distance c2 c0))
                     c4 (polar c0 ang2 (+ (/ (cadr f) 2.0) 6.0))
                     c5 (polar c0 (+ ang2 pi) (distance c4 c0))
                     p3 (polar p2 (- ang1 (* pi 0.25)) (* (sqrt 2.0) (* d 2)))
                     p4 (polar p3 ang1 (- (car f) (* d 4)))
                     p5 (polar p2 ang1 (car f))
                     p6 (polar p1 ang1 (car f))
                     p7 (polar p4 ang2 (cadr f))
                     p8 (polar p3 ang2 (cadr f))
                     p9  (polar p1 ang1 d)
                     p10 (polar p2 ang1 d)
                     p11 (polar p3 ang2 d)
                     p12 (polar p4 ang2 d)
                     p13 (polar p5 (+ ang1 pi) d)
                     p14 (polar p6 (+ ang1 pi) d)
                     p15 (polar p7 (+ ang2 pi) d)
                     p16 (polar p8 (+ ang2 pi) d)
               )
               (setq ad
                  (append ad
                     (list
                        (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p1
                                  p9 p10 p10 p11 p11 p12 p12 p13 p13 p14 p14 p15 p15 p16 p16 p9
                        )
                     )
                  )
               )
               (setq cp (append cp (list p5 p6)))
               (setq cl (append cl (list (list c2 c3 c4 c5))))
            )
            (if (/= b c)
               (princ (strcat "\n[DRAG] direction of " (rtos c 4) " Leg and [PICK]:"))
            )
         )
         ((= STL_INPUT_MODE "stl_ic")
            (setq ang2 (+ ang1 (* pi 0.5)))
            (setq c0 c1)
            (setq c1 (polar c0 (+ ang1 pi) (/ b 2.0)))
            (setq p1 (polar c1 ang2 (- (/ c 2) (* d 2)))
                  p2 (polar c1 (angle p1 c1) (distance p1 c1))
                  c2 (polar c1 (+ ang1 pi) 6.0)
                  c3 (polar c0 ang1 (distance c2 c0))
                  c4 (polar c0 ang2 (+ (/ c 2.0) 6.0))
                  c5 (polar c0 (+ ang2 pi) (distance c4 c0))
                  p3 (polar p2 (- ang1 (* pi 0.25)) (* (sqrt 2.0) (* d 2)))
                  p4 (polar p3 ang1 (- b (* d 4)))
                  p5 (polar p2 ang1 b)
                  p6 (polar p1 ang1 b)
                  p7 (polar p4 ang2 c)
                  p8 (polar p3 ang2 c)
                  p9  (polar p1 ang1 d)
                  p10 (polar p2 ang1 d)
                  p11 (polar p3 ang2 d)
                  p12 (polar p4 ang2 d)
                  p13 (polar p5 (+ ang1 pi) d)
                  p14 (polar p6 (+ ang1 pi) d)
                  p15 (polar p7 (+ ang2 pi) d)
                  p16 (polar p8 (+ ang2 pi) d)
            )
            (setq ad
               (append ad
                  (list
                     (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p1
                               p9 p10 p10 p11 p11 p12 p12 p13 p13 p14 p14 p15 p15 p16 p16 p9
                     )
                  )
               )
            )
            (setq cl (append cl (list (list c2 c3 c4 c5))))
         )
         ((= STL_INPUT_MODE "stl_id")
            (setq ang2 (+ ang1 (* pi 0.5)))
            (setq c0 c1)
            (setq c1 (polar c0 (+ ang1 pi) (/ c 2.0)))
            (setq p1 (polar c1 ang2 (- (/ b 2) (* d 2)))
                  p2 (polar c1 (angle p1 c1) (distance p1 c1))
                  c2 (polar c1 (+ ang1 pi) 6.0)
                  c3 (polar c0 ang1 (distance c2 c0))
                  c4 (polar c0 ang2 (+ (/ b 2.0) 6.0))
                  c5 (polar c0 (+ ang2 pi) (distance c4 c0))
                  p3 (polar p2 (- ang1 (* pi 0.25)) (* (sqrt 2.0) (* d 2)))
                  p4 (polar p3 ang1 (- c (* d 4)))
                  p5 (polar p2 ang1 c)
                  p6 (polar p1 ang1 c)
                  p7 (polar p4 ang2 b)
                  p8 (polar p3 ang2 b)
                  p9  (polar p1 ang1 d)
                  p10 (polar p2 ang1 d)
                  p11 (polar p3 ang2 d)
                  p12 (polar p4 ang2 d)
                  p13 (polar p5 (+ ang1 pi) d)
                  p14 (polar p6 (+ ang1 pi) d)
                  p15 (polar p7 (+ ang2 pi) d)
                  p16 (polar p8 (+ ang2 pi) d)
            )
            (setq ad
               (append ad
                  (list
                     (list 256 p1 p2 p2 p3 p3 p4 p4 p5 p5 p6 p6 p7 p7 p8 p8 p1
                               p9 p10 p10 p11 p11 p12 p12 p13 p13 p14 p14 p15 p15 p16 p16 p9
                     )
                  )
               )
            )
            (setq cl (append cl (list (list c2 c3 c4 c5))))
         )
      )
      (setq d1 (car ad) d2 (cadr ad) t1 d1 t2 (car cl))
      (if (and tgl (/= b c))
         (progn
            (setq p1 (car cp) p2 (cadr cp) p3 (caddr cp) p4 (cadddr cp) ang1 (+ (angle p1 p2) (* pi 0.5)))
            (grvecs d1)
            (grread 5)
            (while (/= 3 (car (setq l (grread 5))))
               (if (= 5 (car l))
                  (progn
                     (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) ang1 12.0) p1 p2 nil)))
                     (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) ang1 12.0) p3 p4 nil)))
                     (if (< n m)
                        (if (not (equal t1 d1))
                           (progn
                              (grvecs t1)
                              (grvecs d1)
                              (setq t1 d1 t2 (car cl))
                           )
                        )
                        (if (not (equal t1 d2))
                           (progn
                              (grvecs t1)
                              (grvecs d2)
                              (setq t1 d2 t2 (cadr cl))
                           )
                        )
                     )
                  )
               )
            )
            (grvecs t1)
         )
      )
      (setq lp (polar (cadr t2) (angle (cadr t2) (car t2)) 6.0))
      (setq d1 (cdr t1))
      (command ".undo" "g")
      (setvar "blipmode" 0)
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (stl_set_lyr "stl-cntr")
      (stl_draw_line (list (car t2) (cadr t2)) nil)
      (stl_draw_line (list (caddr t2) (cadddr t2)) nil)
      (stl_set_lyr "stl-objt")
      (command "pline" (car d1) "w" 0.0 "" (nth 1 d1) "a"
         (nth  3 d1) "l" (nth  5 d1) "a"
         (nth  7 d1) "l" (nth  9 d1) "a"
         (nth 11 d1) "l" (nth 13 d1) "a" (car d1) "cl")
      (setq b (ssadd (entlast)))
      (command "pline" (nth 16 d1) "w" 0.0 "" (nth 17 d1) "a"
         (nth 19 d1) "l" (nth 21 d1) "a"
         (nth 23 d1) "l" (nth 25 d1) "a"
         (nth 27 d1) "l" (nth 29 d1) "a" (nth 16 d1) "cl")
      (setq b (ssadd (entlast) b))
      (if (= STL_HATCH_MODE "stl_ha")
         (progn
            (stl_set_lyr "stl-htch")
            (command ".hatch" "steel" 4.0 (angtos (+ ang1 (* 0.5 pi))) b "")
         )
      )
      (setvar "osmode" r)
      (setvar "blipmode" a)
      (command ".undo" "e")
      (princ (strcat "\nDraw Section of [" (nth 0 SHP_DATA) "] again"))
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" a)
)
'()
)