;Draw TS Shape Elevations
(apply '(lambda ( / ang c d e f g h i j k l m n p r tgl
                    p1 p2 p3 p4 p5 p6 p7 p8 lp)
   (setq p (getvar "blipmode"))
   (princ (strcat "\nDrawing "
      (cond
         ((= STL_VIEW_MODE "stl_va") "Front Elevation")
         ((= STL_VIEW_MODE "stl_vb") "Rear Elevation")
         ((= STL_VIEW_MODE "stl_vc") "Top View")
         ((= STL_VIEW_MODE "stl_vd") "Bottom Section")
      )
      " of [" (nth 0 SHP_DATA) "]")
   )
   (if (not (setq lp (getpoint "\n[PICK] Start point: ")))
      (setq lp (getvar "lastpoint"))
   )
   (while (setq p1 lp p2 (getpoint lp "\n[PICK] End point: "))
      (setq lp p2)
      (command ".undo" "g")
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (setvar "blipmode" 0)
      (setq ang (angle p1 p2))
      (setq a (nth 1 SHP_DATA) b (nth 2 SHP_DATA))
      (setq c (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 3 SHP_DATA)))
      (setq ad nil cp nil)
      (cond
         ((= STL_INPUT_MODE "stl_ia")             ;TOS
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq ang (+ ang (* pi 1.5)) tgl t)
            (foreach f (list a b)
               (setq p3 (polar p2 ang f))
               (setq p4 (polar p1 ang f))
               (setq p5 (polar p1 (angle p1 p4) c))
               (setq p6 (polar p2 (angle p1 p4) c))
               (setq p7 (polar p4 (angle p4 p1) c))
               (setq p8 (polar p3 (angle p4 p1) c))
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p3 p3 p4 p4 p1 p5 p6 p7 p8))
                  )
               )
               (setq cp (append cp (list p4 p3)))
            )
         )
         ((= STL_INPUT_MODE "stl_ib")             ;BOS
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq ang (+ ang (* pi 0.5)) tgl t)
            (foreach f (list a b)
               (setq p3 (polar p2 ang f))
               (setq p4 (polar p1 ang f))
               (setq p5 (polar p1 (angle p1 p4) c))
               (setq p6 (polar p2 (angle p1 p4) c))
               (setq p7 (polar p4 (angle p4 p1) c))
               (setq p8 (polar p3 (angle p4 p1) c))
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p3 p3 p4 p4 p1 p5 p6 p7 p8))
                  )
               )
               (setq cp (append cp (list p4 p3)))
            )
         )
         ((= STL_INPUT_MODE "stl_ic")             ;X Axis
            (setq ang (+ ang (* pi 1.5)))
            (stl_set_lyr "stl-cntr")
            (stl_draw_line
               (list
                  (polar p1 (angle p2 p1) 6.0)
                  (polar p2 (angle p1 p2) 6.0)) nil)
            (setq p1 (polar p1 (+ ang pi) (/ a 2.0)))
            (setq p2 (polar p2 (+ ang pi) (/ a 2.0)))
            (setq p4 (polar p1 ang a))
            (setq p3 (polar p2 ang a))
            (setq p5 (polar p1 (angle p1 p4) c))
            (setq p6 (polar p2 (angle p1 p4) c))
            (setq p7 (polar p4 (angle p4 p1) c))
            (setq p8 (polar p3 (angle p4 p1) c))
            (setq ad
               (list
                  (list 256 p1 p2 p2 p3 p3 p4 p4 p1 p5 p6 p7 p8)
               )
            )
         )
         ((= STL_INPUT_MODE "stl_id")             ;Y Axis
            (setq ang (+ ang (* pi 1.5)))
            (stl_set_lyr "stl-cntr")
            (stl_draw_line
               (list
                  (polar p1 (angle p2 p1) 6.0)
                  (polar p2 (angle p1 p2) 6.0)) nil)
            (setq p1 (polar p1 (+ ang pi) (/ b 2.0)))
            (setq p2 (polar p2 (+ ang pi) (/ b 2.0)))
            (setq p4 (polar p1 ang b))
            (setq p3 (polar p2 ang b))
            (setq p5 (polar p1 (angle p1 p4) c))
            (setq p6 (polar p2 (angle p1 p4) c))
            (setq p7 (polar p4 (angle p4 p1) c))
            (setq p8 (polar p3 (angle p4 p1) c))
            (setq ad
               (list
                  (list 256 p1 p2 p2 p3 p3 p4 p4 p1 p5 p6 p7 p8)
               )
            )
         )
      )
      (setq d1 (car ad) d2 (cadr ad) t1 d1)
      (if (and tgl (/= a b))
         (progn
            (setq p1 (car cp) p2 (cadr cp) p3 (caddr cp) p4 (cadddr cp))
            (grvecs d1)
            (princ (strcat "\n[DRAG] to change size and [PICK]: Displaying " (rtos a 5) "\" Side    "))
            (grread 5)
            (while (/= 3 (car (setq l (grread 5))))
               (if (= 5 (car l))
                  (progn
                     (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) ang 12.0) p1 p2 nil)))
                     (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) ang 12.0) p4 p3 nil)))
                     (if (< n m)
                        (if (not (equal t1 d1))
                           (progn
                              (princ (strcat "\r[DRAG] to change size and [PICK]: Displaying " (rtos a 5) "\" Side    "))
                              (grvecs t1)
                              (grvecs d1)
                              (setq t1 d1)
                           )
                        )
                        (if (not (equal t1 d2))
                           (progn
                              (princ (strcat "\r[DRAG] to change size and [PICK]: Displaying " (rtos b 5) "\" Side    "))
                              (grvecs t1)
                              (grvecs d2)
                              (setq t1 d2)
                           )
                        )
                     )
                  )
               )
            )
            (grvecs t1)
         )
      )
      (setq d1 (cdr t1))
      (command ".undo" "g")
      (stl_set_lyr "stl-objt")
      (stl_draw_line (list (nth 0 d1) (nth 1 d1) (nth 3 d1) (nth 5 d1) (nth 0 d1)) t)
      (cond
         ((/= STL_VIEW_MODE "stl_vd") (stl_set_lyr "stl-hidn"))
         ((= STL_HATCH_MODE "stl_hb"))
         (t
            (stl_set_lyr "stl-htch")
            (command ".pline" (nth 0 d1) "w" 0.0 "" (nth 1 d1) (nth 9 d1) (nth 8 d1) "c")
            (setq a (entlast))
            (command ".hatch" "steel" 4.0 (angtos (+ ang (* 0.5 pi))) a "")
            (setvar "highlight" 0)
            (command ".erase" a "")
            (command ".pline" (nth 5 d1) "w" 0.0 "" (nth 3 d1) (nth 11 d1) (nth 10 d1) "c")
            (setq a (entlast))
            (command ".hatch" "steel" 4.0 (angtos (+ ang (* 0.5 pi))) a "")
            (command ".erase" a "")
            (setvar "highlight" 1)
            (stl_set_lyr "stl-objt")
         )
      )
      (stl_draw_line (list (nth 8 d1) (nth 9 d1)) nil)
      (stl_draw_line (list (nth 10 d1) (nth 11 d1)) nil)
      (setvar "osmode" r)
      (setvar "blipmode" p)
      (command ".undo" "e")
      (princ (strcat "\nDrawing "
         (cond
            ((= STL_VIEW_MODE "stl_va") "Front Elevation")
            ((= STL_VIEW_MODE "stl_vb") "Rear Elevation")
            ((= STL_VIEW_MODE "stl_vc") "Top View")
            ((= STL_VIEW_MODE "stl_vd") "Bottom View")
         )
         " of [" (nth 0 SHP_DATA) "] again")
      )
      (setvar "lastpoint" p2)
   )
   (setvar "blipmode" p)
)
'()
)