;Draw C Shape Top View
(apply '(lambda ( / ang c d e f g h i j k l m n r lp
                    p1 ad cp p1 p2 p3 p4 p5 p6 p7 p8 d1 d2 t1)
   (setq a (getvar "blipmode"))
   (setvar "blipmode" 1)
   (if (= STL_VIEW_MODE "stl_vc")
      (princ (strcat "\nDrawing Top View of [" (nth 0 SHP_DATA) "]"))
      (princ (strcat "\nDrawing Bottom Section of [" (nth 0 SHP_DATA) "]"))
   )
   (if (not (setq lp (getpoint "\n[PICK] Start point: ")))
      (setq lp (getvar "lastpoint"))
   )
   (while (setq p1 lp p2 (getpoint p1 "\n[PICK] End point: "))
      (setq lp p2)
      (setq ang (angle p1 p2) ad nil cp nil)
      (command ".undo" "g")
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (setq j (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq i (+ ang (* pi 1.5))
                  p7 (polar p1 i (/ (nth 3 SHP_DATA) 2.0))
                  p8 (polar p2 i (/ (nth 3 SHP_DATA) 2.0))
            )
            (foreach f (list i (+ i pi))
               (setq p1 (polar p7 (+ f pi) (/ (nth 3 SHP_DATA) 2.0)))
               (setq p2 (polar p8 (+ f pi) (/ (nth 3 SHP_DATA) 2.0)))
               (setq p3 (polar p1 f (nth 3 SHP_DATA)))
               (setq p4 (polar p2 f (nth 3 SHP_DATA)))
               (setq p5 (polar p1 f j) p6 (polar p2 f j))
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p5 p6))
                  )
               )
               (setq cp (append cp (list p3 p4)))
            )
         )
         ((= STL_INPUT_MODE "stl_ib")
            (if (and (> ang (* 0.5 pi)) (<= ang (* 1.5 pi)))
               (setq ang p1 p1 p2 p2 ang ang (angle p1 p2))
            )
            (setq i (+ ang (* pi 0.5))
                  p7 (polar p1 i (/ (nth 3 SHP_DATA) 2.0))
                  p8 (polar p2 i (/ (nth 3 SHP_DATA) 2.0))
            )
            (foreach f (list i (+ i pi))
               (setq p1 (polar p7 (+ f pi) (/ (nth 3 SHP_DATA) 2.0)))
               (setq p2 (polar p8 (+ f pi) (/ (nth 3 SHP_DATA) 2.0)))
               (setq p3 (polar p1 f (nth 3 SHP_DATA)))
               (setq p4 (polar p2 f (nth 3 SHP_DATA)))
               (setq p5 (polar p1 f j) p6 (polar p2 f j))
               (setq ad
                  (append ad
                     (list (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p5 p6))
                  )
               )
               (setq cp (append cp (list p3 p4)))
            )
         )
         ((= STL_INPUT_MODE "stl_id")
            (setq i (+ ang (* pi 1.5)) p7 p1 p8 p2)
            (stl_set_lyr "stl-cntr")
            (setvar "blipmode" 0)
            (command ".line"
               (polar p1 (angle p2 p1) 6.0)
               (polar p2 (angle p1 p2) 6.0) "")
            (foreach f (list i (+ i pi))
               (setq p1 (polar p7 f (nth 8 SHP_DATA)))
               (setq p2 (polar p8 f (nth 8 SHP_DATA)))
               (setq p3 (polar p1 (+ f pi) (nth 3 SHP_DATA)))
               (setq p4 (polar p2 (+ f pi) (nth 3 SHP_DATA)))
               (setq p5 (polar p1 (angle p1 p3) j) p6 (polar p2 (angle p2 p4) j))
               (setq ad
                  (append ad
                     (list
                        (list 256 p1 p2 p2 p4 p4 p3 p3 p1 p5 p6)
                     )
                  )
               )
               (setq cp (append cp (list p3 p4)))
            )
         )
      )
      (setq d1 (car ad) d2 (cadr ad) t1 d1)
      (setq p1 (car cp) p2 (cadr cp) p3 (caddr cp) p4 (cadddr cp))
      (grvecs d1)
      (princ "\n[DRAG] Toe direction and [PICK]: ")
      (grread 5)
      (while (/= 3 (car (setq l (grread 5))))
         (if (= 5 (car l))
            (progn
               (setq n (distance (cadr l) (inters (cadr l) (polar (cadr l) i 12.0) p1 p2 nil)))
               (setq m (distance (cadr l) (inters (cadr l) (polar (cadr l) i 12.0) p3 p4 nil)))
               (if (< n m)
                  (if (not (equal t1 d1))
                     (progn
                        (grvecs t1)
                        (grvecs d1)
                        (setq t1 d1)
                     )
                  )
                  (if (not (equal t1 d2))
                     (progn
                        (grvecs t1)
                        (grvecs d2)
                        (setq t1 d2)
                     )
                  )
               )
            )
         )
      )
      (grvecs t1)
      (setq d1 (cdr t1))
      (setvar "blipmode" 0)
      (stl_set_lyr "stl-objt")
      (stl_draw_line
         (list (nth 0 d1) (nth 1 d1) (nth 3 d1) (nth 5 d1)) t)
      (if (= STL_VIEW_MODE "stl_vc")
         (progn
            (stl_set_lyr "stl-hidn")
            (stl_draw_line (list (nth 8 d1) (nth 9 d1)) nil)
         )
         (progn
            (if (= STL_HATCH_MODE "stl_ha")
               (progn
                  (command ".pline" (nth 0 d1) "w" 0.0 "" (nth 1 d1) (nth 9 d1) (nth 8 d1) "c")
                  (setq b (entlast))
                  (stl_set_lyr "stl-htch")
                  (command ".hatch" "steel" 4.0 (angtos ang) b "")
                  (setvar "highlight" 0)
                  (command ".erase" b "")
                  (setvar "highlight" 1)
               )
            )
            (stl_draw_line (list (nth 8 d1) (nth 9 d1)) nil)
         )
      )
      (setvar "blipmode" a)
      (setvar "osmode" r)
      (command ".undo" "e")
      (if (= STL_VIEW_MODE "stl_va")
         (princ (strcat "\nDrawing Top View of [" (nth 0 SHP_DATA) "]"))
         (princ (strcat "\nDrawing Bottom Section of [" (nth 0 SHP_DATA) "]"))
      )
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" a)
)
'()
)